/**
 * Little AbortController proxy module so we can swap out the implementation easily later.
 */

import { AbortController, AbortSignal } from 'abortcontroller-polyfill/dist/abortcontroller';
import { ABORTED_ERROR } from './constants';
function createAbortError() {
  var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : ABORTED_ERROR === null || ABORTED_ERROR === void 0 ? void 0 : ABORTED_ERROR.message;
  try {
    return new DOMException(message, 'AbortError');
  } catch (_unused) {
    // For Internet Explorer
    var error = new Error(message);
    error.name = 'AbortError';
    return error;
  }
}
exports.AbortController = AbortController;
exports.AbortSignal = AbortSignal;
exports.createAbortError = createAbortError;