function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _wrapNativeSuper(t) { var r = "function" == typeof Map ? new Map() : void 0; return _wrapNativeSuper = function _wrapNativeSuper(t) { if (null === t || !_isNativeFunction(t)) return t; if ("function" != typeof t) throw new TypeError("Super expression must either be null or a function"); if (void 0 !== r) { if (r.has(t)) return r.get(t); r.set(t, Wrapper); } function Wrapper() { return _construct(t, arguments, _getPrototypeOf(this).constructor); } return Wrapper.prototype = Object.create(t.prototype, { constructor: { value: Wrapper, enumerable: !1, writable: !0, configurable: !0 } }), _setPrototypeOf(Wrapper, t); }, _wrapNativeSuper(t); }
function _construct(t, e, r) { if (_isNativeReflectConstruct()) return Reflect.construct.apply(null, arguments); var o = [null]; o.push.apply(o, e); var p = new (t.bind.apply(t, o))(); return r && _setPrototypeOf(p, r.prototype), p; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _isNativeFunction(t) { try { return -1 !== Function.toString.call(t).indexOf("[native code]"); } catch (n) { return "function" == typeof t; } }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
export var DATA_TIME_OPT_KEYS = {
  DATE_TIME_LONG: 'dateTimeLong',
  DATE_ONLY: 'dateOnly'
};
export var DATE_ONLY_OPTIONS = {
  year: 'numeric',
  month: 'short',
  day: 'numeric'
};
export var TIME_ONLY_OPTIONS = {
  hour: 'numeric',
  minute: '2-digit'
};
export var DATE_TIME_OPTIONS = {
  year: 'numeric',
  month: 'short',
  day: 'numeric',
  hour: '2-digit',
  minute: '2-digit'
};

/**
 * CustomDate is wrapped Date class created to provide more useful methods.
 */
var CustomDate = /*#__PURE__*/function (_Date) {
  function CustomDate() {
    _classCallCheck(this, CustomDate);
    return _callSuper(this, CustomDate, arguments);
  }
  _inherits(CustomDate, _Date);
  return _createClass(CustomDate, [{
    key: "getUTCOffsetInMinutes",
    value:
    /**
     * @returns {number} Timezone offset in minutes for specified date (could be difference according to DST (for ex. CET and CEST time))
     */
    function getUTCOffsetInMinutes() {
      return -this.getTimezoneOffset();
    }

    /**
     * @returns {number} Current timezone offset in hours
     */
  }, {
    key: "getHoursString",
    value:
    /**
     * @returns {string} Get amount of hours as a 2 symbols string
     */
    function getHoursString() {
      return "0".concat(this.getHours()).slice(-2);
    }

    /**
     * @returns {string} Get amount of minutes as a 2 symbols string
     */
  }, {
    key: "getMinutesString",
    value: function getMinutesString() {
      return "0".concat(this.getMinutes()).slice(-2);
    }

    /**
     * Notice! This method send month from 1-12, not the same as getMonth when month count starts from 0
     * @returns {string} Get amount of months as a 2 symbols string
     */
  }, {
    key: "getMonthString",
    value: function getMonthString() {
      return "0".concat(this.getMonth() + 1).slice(-2);
    }

    /**
     * @returns {string} Get date as a 2 symbols string
     */
  }, {
    key: "getDateString",
    value: function getDateString() {
      return "0".concat(this.getDate()).slice(-2);
    }

    /**
     * @param {string} [language="en"]
     * @param {string|object} [dateTimeOpts="dateTimeLong"] - Preset name dateTimeLong|dateOnly or opts object for toLocaleTimeString method
     * @returns {string} Formatted date and time value, for instance "Apr 8, 2024 12:00 AM"
     */
  }, {
    key: "getFormattedDate",
    value: function getFormattedDate() {
      var language = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'en';
      var dateTimeOpts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DATA_TIME_OPT_KEYS.DATE_TIME_LONG;
      switch (dateTimeOpts) {
        case DATA_TIME_OPT_KEYS.DATE_TIME_LONG:
          return "".concat(this.toLocaleDateString(language, DATE_ONLY_OPTIONS), " ").concat(this.toLocaleTimeString(language, TIME_ONLY_OPTIONS));
        case DATA_TIME_OPT_KEYS.DATE_ONLY:
          return this.toLocaleDateString(language, DATE_ONLY_OPTIONS);
        default:
          return this.toLocaleTimeString(language, _typeof(dateTimeOpts) === 'object' ? dateTimeOpts : DATE_TIME_OPTIONS);
      }
    }
  }], [{
    key: "getCurrentUTCOffsetInMinutes",
    value:
    /**
     * @returns {number} Current timezone offset in minutes
     */
    function getCurrentUTCOffsetInMinutes() {
      return -new Date().getTimezoneOffset();
    }
  }, {
    key: "getCurrentUTCOffset",
    value: function getCurrentUTCOffset() {
      return this.getCurrentUTCOffsetInMinutes() / 60;
    }

    /**
     * @param {Object} opts
     * @param {boolean} [opts.withUTCPrefix=false] - If it's TRUE returned value will be like "UTC+2" otherwise "+2"
     * @returns {string} Current timezone offset string like "UTC+2"
     */
  }, {
    key: "getCurrentUTCOffsetString",
    value: function getCurrentUTCOffsetString() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$withUTCPrefix = _ref.withUTCPrefix,
        withUTCPrefix = _ref$withUTCPrefix === void 0 ? false : _ref$withUTCPrefix;
      var offset = this.getCurrentUTCOffset();
      return "".concat(withUTCPrefix ? 'UTC' : '').concat(offset > -1 ? '+' : '-').concat(offset);
    }

    /**
     * @returns {string} TimeZone label, for ex. "Europe/Zagreb"
     */
  }, {
    key: "getTimezone",
    value: function getTimezone() {
      return Intl.DateTimeFormat().resolvedOptions().timeZone;
    }
  }]);
}(/*#__PURE__*/_wrapNativeSuper(Date));
export { CustomDate as default };