var getDateRange = function getDateRange(dateRange) {
  var formatDate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (newDate) {
    return newDate;
  };
  var isFuture = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var min = 60 * 1000;
  var hour = 60 * min;
  var day = 24 * hour;
  var date = '';
  var getDateFormat = function getDateFormat(timeFrame) {
    return formatDate(new Date(isFuture ? Date.now() + timeFrame * day : Date.now() - timeFrame * day));
  };
  switch (Math.abs(dateRange)) {
    case 0:
      // Today
      date = getDateFormat(0);
      break;
    case 1:
      // Past/next 24 hours (1 day)
      date = getDateFormat(1);
      break;
    case 2:
      // Past/next 7 days (1 week)
      date = getDateFormat(7);
      break;
    case 3:
      // Past/next 30 days (1 month)
      date = getDateFormat(30);
      break;
    case 4:
      // Past/next 90 days (3 months)
      date = getDateFormat(90);
      break;
    case 5:
      // Past/next 180 days (6 months)
      date = getDateFormat(180);
      break;
    case 6:
      // past/next 365 days (1 year)
      date = getDateFormat(365);
      break;
  }
  return date;
};
export default getDateRange;