function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { I18N_GRID_UUID, I18N_PROD_BASE_URL } from '@filerobot/utils/lib/constants';

/**
 * Class to console log all missing translation keys and generate curl for convenience.
 *
 * How to use?
 *  - Create instance for your project:
 *    const missingKeysConsoleHelper = new TranslationMissingKeysConsoleHelper({ name, gridUuid, ... })
 *    > Notice! Each project should have only one instance of the class (e.g one instance for Hub and one more for Widget)
 *  - Run method handleMissingKey each time when missing key detected:
 *    missingKeysConsoleHelper.handleMissingKey(key, valueOrDefault)
 *  - Enable console helper by adding localStorage prop "translationMissingKeysConsoleHelperEnabled"=true OR by enabled config
 * As the result you should see all missing keys in browser console with generated cURL for convenience.
 *
 * IMPORTANT! For any updates in the class need to sync and double check Hub project as well!
 */
var TranslationMissingKeysConsoleHelper = /*#__PURE__*/function () {
  function TranslationMissingKeysConsoleHelper() {
    var _this = this;
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      name = _ref.name,
      baseApiUrl = _ref.baseApiUrl,
      gridUuid = _ref.gridUuid,
      debounceDelay = _ref.debounceDelay,
      _ref$consoleGroupColl = _ref.consoleGroupCollapsed,
      consoleGroupCollapsed = _ref$consoleGroupColl === void 0 ? false : _ref$consoleGroupColl,
      _ref$enabled = _ref.enabled,
      enabled = _ref$enabled === void 0 ? localStorage.getItem('translationMissingKeysConsoleHelperEnabled') === 'true' : _ref$enabled;
    _classCallCheck(this, TranslationMissingKeysConsoleHelper);
    _defineProperty(this, "name", 'WIDGET');
    // Name is used in logs titles. Useful when class is used for multiple projects (e.g. Hub and Widget)
    _defineProperty(this, "baseApiUrl", I18N_PROD_BASE_URL);
    _defineProperty(this, "gridUuid", I18N_GRID_UUID);
    _defineProperty(this, "debounceDelay", 2000);
    // Delay to not console log too often
    _defineProperty(this, "consoleGroupCollapsed", false);
    _defineProperty(this, "enabled", false);
    _defineProperty(this, "_missingKeys", {});
    _defineProperty(this, "_timer", null);
    if (name) {
      this.name = name;
    }
    if (baseApiUrl) {
      this.baseApiUrl = baseApiUrl;
    }
    if (gridUuid) {
      this.gridUuid = gridUuid;
    }
    if (debounceDelay) {
      this.debounceDelay = debounceDelay;
    }
    if (enabled === true) {
      this.enabled = true;
      console.log("%cTranslationMissingKeysConsoleHelper enabled for ".concat(this.name), 'font-weight:600;');
    }
    this.consoleGroupCollapsed = consoleGroupCollapsed;
    this.renderCurl = this.renderCurl.bind(this);
    this._missingKeys = new Proxy(this._missingKeys, {
      set: function set(target, propName, value, receiver) {
        if (_this._timer) {
          clearTimeout(_this._timer);
        }
        _this._timer = setTimeout(_this.renderCurl, _this.debounceDelay);
        return Reflect.set(target, propName, value, receiver);
      }
    });
  }
  return _createClass(TranslationMissingKeysConsoleHelper, [{
    key: "renderCurl",
    value: function renderCurl() {
      console[this.consoleGroupCollapsed ? 'groupCollapsed' : 'group']("[".concat(this.name, "] Translations missing keys group"));
      console.log("%c[".concat(this.name, "] Missing keys"), 'font-weight:600;font-size:200%;');
      console.table(_objectSpread({}, this._missingKeys));
      console.log('%ccURL (check carefully data before send):', 'font-weight:600;font-size:150%;');
      console.log("\ncurl '".concat(this.baseApiUrl, "/api/import/request-translations?grid_uuid=").concat(this.gridUuid, "' \\\n  --data-raw '{\"grid_uuid\":\"").concat(this.gridUuid, "\",\"translations_requests\":").concat(JSON.stringify(Object.entries(this._missingKeys).map(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
          key = _ref3[0],
          value = _ref3[1];
        return {
          key: key,
          lang: 'en',
          "default": value
        };
      })).replaceAll("'", "'\\''"), "}'\n    "));
      console.groupEnd();
    }
  }, {
    key: "handleMissingKey",
    value: function handleMissingKey(key) {
      var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
      if (!this.enabled) {
        return;
      }
      this._missingKeys[key] = value;
    }
  }]);
}();
export { TranslationMissingKeysConsoleHelper as default };