function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import has from './hasProperty';
// import { sendMissingTranslationToBackend } from './i18n.client'
import TranslationMissingKeysConsoleHelper from './TranslationMissingKeysConsoleHelper';

/**
 * Translates strings with interpolation & pluralization support.
 * Extensible with custom dictionaries and pluralization functions.
 *
 * Borrows heavily from and inspired by Polyglot https://github.com/airbnb/polyglot.js,
 * basically a stripped-down version of it. Differences: pluralization functions are not hardcoded
 * and can be easily added among with dictionaries, nested objects are used for pluralization
 * as opposed to `||||` delimeter
 *
 * Usage example: `translator.translate('files_chosen', {smart_count: 3})`
 */

var sentKeys = {};
var missingKeysConsoleHelper = new TranslationMissingKeysConsoleHelper();
var Translator = /*#__PURE__*/function () {
  /**
   * @param {object|Array<object>} locales - locale or list of locales.
   */
  function Translator(locales) {
    var _this = this;
    _classCallCheck(this, Translator);
    this.locale = {
      strings: {},
      pluralize: function pluralize(n) {
        if (n === 1) {
          return 0;
        }
        return 1;
      }
    };
    if (Array.isArray(locales)) {
      locales.forEach(function (locale) {
        return _this._apply(locale);
      });
    } else {
      this._apply(locales);
    }
  }
  return _createClass(Translator, [{
    key: "_apply",
    value: function _apply(locale) {
      if (!locale || !locale.strings) {
        return;
      }
      var prevLocale = this.locale;
      var keysHaveTranslations = Object.keys(locale.strings).filter(function (k) {
        return locale.strings[k];
      });
      var preparedLocaleStrings = {};
      keysHaveTranslations.forEach(function (k) {
        preparedLocaleStrings[k] = locale.strings[k];
      });
      this.locale = _extends({}, prevLocale, {
        strings: _extends({}, prevLocale.strings, preparedLocaleStrings)
      });
      this.locale.pluralize = locale.pluralize || prevLocale.pluralize;
    }

    /**
     * Takes a string with placeholder variables like `%{smart_count} file selected`
     * and replaces it with values from options `{smart_count: 5}`
     *
     * @license https://github.com/airbnb/polyglot.js/blob/master/LICENSE
     * taken from https://github.com/airbnb/polyglot.js/blob/master/lib/polyglot.js#L299
     *
     * @param {string} phrase that needs interpolation, with placeholders
     * @param {object} options with values that will be used to replace placeholders
     * @returns {string} interpolated
     */
  }, {
    key: "interpolate",
    value: function interpolate(phrase, options) {
      var split = String.prototype.split;
      var interpolated = [phrase];
      for (var arg in options) {
        if (arg !== '_' && has(options, arg)) {
          var replacement = options[arg];
          // We create a new `RegExp` each time instead of using a more-efficient
          // string replace so that the same argument can be replaced multiple times
          // in the same phrase.
          interpolated = insertReplacement(interpolated, new RegExp('%\\{' + arg + '\\}', 'g'), replacement);
        }
      }
      return interpolated;
      function insertReplacement(source, rx, replacement) {
        var newParts = [];
        source.forEach(function (chunk) {
          // When the source contains multiple placeholders for interpolation,
          // we should ignore chunks that are not strings, because those
          // can be JSX objects and will be otherwise incorrectly turned into strings.
          // Without this condition we’d get this: [object Object] hello [object Object] my <button>
          if (typeof chunk !== 'string') {
            return newParts.push(chunk);
          }
          split.call(chunk, rx).forEach(function (raw, i, list) {
            if (raw !== '') {
              newParts.push(raw);
            }

            // Interlace with the `replacement` value
            if (i < list.length - 1) {
              newParts.push(replacement);
            }
          });
        });
        return newParts;
      }
    }

    /**
     * Public translate method
     *
     * @param {string} key
     * @param {object} options with values that will be used later to replace placeholders in string
     * @returns {string} translated (and interpolated)
     */
  }, {
    key: "translate",
    value: function translate(key, options) {
      var _this$translateArray;
      return (_this$translateArray = this.translateArray(key, options)) === null || _this$translateArray === void 0 ? void 0 : _this$translateArray.join('');
    }

    /**
     * Get a translation and return the translated and interpolated parts as an array.
     *
     * @param {string} key
     * @param {object} options with values that will be used to replace placeholders or default string value if key doesn't have value
     *                        - string => used as default value
     *                        - object => uses the `default` property as the translation default value and others for placeholder.
     * @returns {Array} The translated and interpolated parts, in order.
     */
  }, {
    key: "translateArray",
    value: function translateArray(key, options) {
      if (!Translator.BACKEND_TRANSLATIONS) {
        return [];
      }
      // JSON.parse() for handling the plural case that's being received from backend as string.
      try {
        var _this$locale$strings$, _this$locale$strings$2, _options$default;
        var value = (_this$locale$strings$ = this.locale.strings[key]) !== null && _this$locale$strings$ !== void 0 && (_this$locale$strings$2 = _this$locale$strings$.startsWith) !== null && _this$locale$strings$2 !== void 0 && _this$locale$strings$2.call(_this$locale$strings$, '{"') ? JSON.parse(this.locale.strings[key]) : this.locale.strings[key];
        var valueOrDefault = !value && typeof options === 'string' ? options : (_options$default = options === null || options === void 0 ? void 0 : options["default"]) !== null && _options$default !== void 0 ? _options$default : value || '';
        var hasPluralForms = _typeof(value) === 'object';

        // For sending to the backend the missing translation keys
        if (key && Translator.BACKEND_TRANSLATIONS && !Translator.BACKEND_TRANSLATIONS[key] && !sentKeys[key]) {
          var valueOrDefaultWithStrPlural = hasPluralForms ? JSON.stringify(valueOrDefault) : valueOrDefault;

          /**
           * Auto translations disabled. Should be used manual creation instead of that.
           * As a helper could be used "Missing keys Console Helper" -- https://scaleflexhq.atlassian.net/wiki/spaces/FIL/pages/594444447/Hub+Widget+projects+translations#Missing-keys-Console-Helper
           */
          // if (!Translator.IS_DEV) {
          //   sendMissingTranslationToBackend({
          //     key,
          //     fallBackLang: 'en',
          //     lang: 'en',
          //     default: valueOrDefaultWithStrPlural
          //   })
          // }

          missingKeysConsoleHelper.handleMissingKey(key, valueOrDefaultWithStrPlural);
          sentKeys[key] = true;
          Translator.BACKEND_TRANSLATIONS = _objectSpread(_objectSpread({}, Translator.BACKEND_TRANSLATIONS), {}, _defineProperty({}, key, valueOrDefault));
        }
        if (hasPluralForms) {
          if (options && _typeof(options) === 'object' && typeof options.smart_count !== 'undefined') {
            var plural = this.locale.pluralize(options.smart_count);
            return this.interpolate(value[plural], options);
          } else {
            throw new Error('Attempted to use a string with plural forms, but no value was given for %{smart_count}');
          }
        }
        return this.interpolate(value, options);
      } catch (err) {}
    }
  }]);
}();
// For saving the backend translations retrieved from core.
_defineProperty(Translator, "BACKEND_TRANSLATIONS", null);
// For saving the current environment of the project, determined from core.
_defineProperty(Translator, "IS_DEV", true);
// For knowing the current used language incase some missing key is faced then send to the backend in right lang.
_defineProperty(Translator, "LANGUAGE", 'en');
export { Translator as default };