/**
 * Method to fix <video> support issue for *.mov (video/quicktime) video type (maybe some other types later).
 * To make mov video works good we need to use "video/mp4" type instead of "video/quicktime".
 *
 * Scaban card: https://sfx.li/MVcgYtX894WiUD (ID T11986)
 *
 * Since the browser doesn't supproted .mkv videos, used same idea as *.mov videos and works (but not sure if it works with no issues and for all the browsers or not)
 * Jira's card URL: https://scaleflexhq.atlassian.net/browse/FRA-2494
 *
 */
var convertVideoFileTypeToSupported = function convertVideoFileTypeToSupported(videoFileType) {
  if (videoFileType === 'video/quicktime' || videoFileType === 'video/x-matroska') {
    return 'video/mp4';
  }
  return videoFileType;
};
export default convertVideoFileTypeToSupported;