function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/*
  Task: https://scaleflexhq.atlassian.net/browse/FRA-4340

  Julian, [27 Jan 2024 at 06:47:04 (27 Jan 2024 at 06:48:19)]:
  I think the debugging would be much easier so it wil make save time to all PO, QA, etc. — so overall I think it's a very impactful todo

  In general, chars that need to be URL encoded are spaces, very special characters like:
  — # bcs it's the anchor
  — % bcs it's the start of an url encoded,
  —  & of course bcs it's param delimiter
  — and  +  since it means an encoded-space
  — and maybe other  non-printable ASCII characters

  but for our cases here, things like >, <, / .., : etc don't need to be URL-encoded
  maybe a way to make this todo very very simple first at low risk is simply to "re-encode" 2 chars :
  %2F -> /
  %2C -> :
  %3A -> ,

  I think just this will fix 98% of our QA-PO- etc misunderstanding and make debugging much easier
  when people look at Network console and copy paste things
*/

export var customEncodeURIComponent = function customEncodeURIComponent(str, opts) {
  if (!str || typeof str !== 'string') {
    return str;
  }
  var options = _objectSpread({
    ignoreSymbols: [':', ',', '.', '@', '=', '+']
  }, opts || {});
  var ignoreSymbols = options.ignoreSymbols || [];
  return Array.isArray(ignoreSymbols) && ignoreSymbols.length > 0 ? _toConsumableArray(str).map(function (_char) {
    return ignoreSymbols.includes(_char) ? _char : encodeURIComponent(_char);
  }).join('') : encodeURIComponent(str);
};