function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
import getDateRange from './Timeframes/getDateRange';
import { FILTER_CONDITIONS } from './constants';
import isNumber from './isNumber';
import literalDateFromDateObj from './literalDateFromDateObj';
export var getFieldValueQuery = function getFieldValueQuery(metadataFilter, value) {
  var key = metadataFilter.key,
    _metadataFilter$condi = metadataFilter.condition,
    condition = _metadataFilter$condi === void 0 ? FILTER_CONDITIONS.IS : _metadataFilter$condi,
    _metadataFilter$opera = metadataFilter.operator,
    operator = _metadataFilter$opera === void 0 ? ':' : _metadataFilter$opera;
  var conditionPrefix = condition === FILTER_CONDITIONS.IS_NOT ? '-' : '';
  return "".concat(key).concat(operator).concat(conditionPrefix).concat(value);
};
export var getDateFieldQuery = function getDateFieldQuery(metadataFilter) {
  var value = metadataFilter.value;
  var query = isNumber(value) ? getDateRange(value, literalDateFromDateObj, value > -1) : value;
  if (Array.isArray(query)) {
    query = _toConsumableArray(query);
    if (isNumber(query[0])) {
      query[0] = getDateRange(query[0], literalDateFromDateObj, query[0] > -1);
    }
    if (isNumber(query[1])) {
      query[1] = getDateRange(query[1], literalDateFromDateObj, query[1] > -1);
    }
    if (query.length === 2) {
      query = "".concat(query[0] || '', "..").concat(query[1] || '');
    }
  }
  return "\"".concat(getFieldValueQuery(metadataFilter, query), "\"");
};
export var getTextFieldQuery = function getTextFieldQuery(metadataFilter) {
  var key = metadataFilter.key,
    value = metadataFilter.value,
    _metadataFilter$condi2 = metadataFilter.condition,
    condition = _metadataFilter$condi2 === void 0 ? FILTER_CONDITIONS.IS : _metadataFilter$condi2;
  if (condition === FILTER_CONDITIONS.IS) {
    return "".concat(key, ":\"").concat(value, "\"");
  }
  return "".concat(key, "~\"").concat(value, "\"");
};