import isDOMElement from './isDOMElement';

/**
 * Find a DOM element.
 *
 * @param {Node|string} element
 * @returns {Node|null}
 */
export default function findDOMElement(element) {
  var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;
  if (typeof element === 'string') {
    return context.querySelector(element);
  }
  if (isDOMElement(element)) {
    return element;
  }
}