export var convertToLocaleNumber = function convertToLocaleNumber(value, language) {
  if (!language || value !== 0 && !value) return value;
  try {
    var _value$toString$trim;
    var splitValue = (_value$toString$trim = value.toString().trim()) === null || _value$toString$trim === void 0 ? void 0 : _value$toString$trim.match(/[a-z]+|[^a-z]+/gi);
    var formattedValue = splitValue.map(function (val) {
      return isNaN(val) ? val : new Intl.NumberFormat(language, {
        maximumFractionDigits: 20
      }).format(val);
    });
    return formattedValue.join(' ');
  } catch (e) {
    return value;
  }
};
export var toInitialNumber = function toInitialNumber(value) {
  var separator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '.';
  if (!value) {
    return value;
  }
  return ((value === null || value === void 0 ? void 0 : value.toString()) || '').replace(new RegExp("[^0-9".concat(separator, "]"), 'g'), '').replace(',', '.');
};
export var getLocaleNumberSeparator = function getLocaleNumberSeparator() {
  var language = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'en-US';
  var separator;
  try {
    separator = new Intl.NumberFormat(language).format('0.1') === '0.1' ? '.' : ',';
  } catch (e) {
    separator = '';
  }
  return separator;
};