/**
 * Formats resolution from 1200x800 to 1200 x 800 px
 *
 * @returns {string}
 *
 * @param {string} resolution -- Resolution as string
 * @param {string} separator -- Separator that should be replaced
 * @param {string} newSeparator -- Separator that should be placed
 * @param {boolean} addPx -- Either add px at the end or not
 */
export default (function () {
  var resolution = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var separator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'x';
  var newSeparator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'x';
  var addPx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  return resolution.replace(separator, " ".concat(newSeparator, " ")) + (addPx ? ' px' : '');
});