function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
/**
 * Get url prefixed by Cloudimage, to be able to process original image and cache it on CDN.
 * @param {string} url - Original URL
 * @param {object} opts
 * @param {object} opts.params - Cloudimage params (https://docs.scaleflex.com/filerobot-documentation/media-optimizers-and-cdn-delivery/image-optimization)
 * @returns {string} - Prefixed url with params
 */
var getCloudimagePrefixedUrl = function getCloudimagePrefixedUrl(url, opts) {
  var _url$split;
  var _ref = opts || {},
    _ref$params = _ref.params,
    params = _ref$params === void 0 ? {} : _ref$params;
  if (typeof url !== 'string') {
    return url;
  }
  var formattedUrl = (_url$split = url.split('?')) === null || _url$split === void 0 ? void 0 : _url$split[0];
  var paramsStr = params && _typeof(params) === 'object' ? Object.keys(params).map(function (paramName) {
    return "".concat(paramName, "=").concat(params[paramName]);
  }).join('&') : '';
  return "https://assets.filerobot.com/v7/".concat(formattedUrl).concat(paramsStr ? '?' : '').concat(paramsStr);
};
export default getCloudimagePrefixedUrl;