import { ONE_DAY_MS } from './constants';
var ONE_MIN_IN_MS = 1000 * 60;
/**
 * Returns a date days from now
 * @param {Number} days - sets the new date by adding the provided number of days for the current date
 * @param {Boolean} timeExcluded - either to return timestamp with time (hours, minutes etc) or without
 * @returns {number} - timestamp in milliseconds
 */

export default (function (_ref) {
  var days = _ref.days,
    _ref$timeExcluded = _ref.timeExcluded,
    timeExcluded = _ref$timeExcluded === void 0 ? true : _ref$timeExcluded;
  var todayTimestamp = timeExcluded ? Date.now() - Date.now() % ONE_DAY_MS + new Date().getTimezoneOffset() * ONE_MIN_IN_MS : Date.now();
  var now = new Date(todayTimestamp);
  return now.setDate(now.getDate() + days);
});