export default (function () {
  var _file$info, _file$info2;
  var file = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var notFoundStr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var neglectMimeType = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var ext = file.extension || ((_file$info = file.info) === null || _file$info === void 0 ? void 0 : _file$info.ext) || ((_file$info2 = file.info) === null || _file$info2 === void 0 ? void 0 : _file$info2.img_type);
  if (ext) {
    return ext;
  }
  var fileMeta = file.meta;
  if (fileMeta && fileMeta.img_type) {
    return fileMeta.img_type;
  }
  var fileMime = file.mime || file.file_type;
  var mimeSeparatorIndex = fileMime === null || fileMime === void 0 ? void 0 : fileMime.lastIndexOf('/');
  if (fileMime && mimeSeparatorIndex && mimeSeparatorIndex !== -1 && !neglectMimeType) {
    return fileMime.slice(mimeSeparatorIndex + 1);
  }
  var fileName = file.name;
  var nameSeparatorIndex = fileName === null || fileName === void 0 ? void 0 : fileName.lastIndexOf('.');
  if (fileName && nameSeparatorIndex && nameSeparatorIndex !== -1) {
    var fileExtension = fileName.slice(nameSeparatorIndex + 1);
    var fileExtensionEndIndex = fileExtension.search(/[^\w\d]/);
    return fileExtensionEndIndex !== -1 ? fileExtension.slice(0, fileExtensionEndIndex) : fileExtension;
  }
  var fileType = file.type;
  var typeSeparatorIndex = fileType === null || fileType === void 0 ? void 0 : fileType.lastIndexOf('/');
  if (fileType && typeSeparatorIndex && typeSeparatorIndex !== -1) {
    return fileType.slice(typeSeparatorIndex + 1);
  }
  return notFoundStr;
});