/**
 * Takes a full filename string and returns an object {name, extension}
 *
 * @param {string} fullFileName
 * @returns {object} {name, extension}
 */
export default function getFileNameAndExtension(fullFileName, fileType) {
  var lastDot = fullFileName.lastIndexOf('.');
  // these count as no extension: "no-dot", "trailing-dot."
  if (lastDot === -1 || lastDot === fullFileName.length - 1) {
    var _fileType$split;
    return {
      name: fullFileName,
      extension: fileType === null || fileType === void 0 ? void 0 : (_fileType$split = fileType.split('/')) === null || _fileType$split === void 0 ? void 0 : _fileType$split[1]
    };
  } else {
    return {
      name: fullFileName.slice(0, lastDot),
      extension: fullFileName.slice(lastDot + 1)
    };
  }
}