import { TIME_OPTIONS } from './constants';
export default (function (folder, language) {
  var _folder$size, _folder$count, _folder$count2;
  var uuid = folder.uuid;
  var name = folder.name;
  var path = folder.path;
  var type = folder.type || 'folder';
  var size = (_folder$size = folder.size) === null || _folder$size === void 0 ? void 0 : _folder$size.total_recursive_pretty;
  var filesRecursive = folder === null || folder === void 0 ? void 0 : (_folder$count = folder.count) === null || _folder$count === void 0 ? void 0 : _folder$count.files_recursive;
  var filesDirect = folder === null || folder === void 0 ? void 0 : (_folder$count2 = folder.count) === null || _folder$count2 === void 0 ? void 0 : _folder$count2.files_direct;
  var updadtedAt = folder.updated_at ? new Date(folder.updated_at).toLocaleTimeString(language, TIME_OPTIONS) : '';
  var createdAt = folder.created_at ? new Date(folder.created_at).toLocaleTimeString(language, TIME_OPTIONS) : '';
  var visibility = folder.visibility;
  var filesCount = folder.filesCount;
  var assetsPreviews = folder.assetsPreviews;
  return {
    uuid: uuid,
    name: name,
    path: path,
    type: type,
    size: size,
    filesRecursive: filesRecursive,
    filesDirect: filesDirect,
    updadtedAt: updadtedAt,
    createdAt: createdAt,
    visibility: visibility,
    filesCount: filesCount,
    assetsPreviews: assetsPreviews
  };
});