function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { FILEROBOT_FILE_URL_REGEX, FILEROBOT_V3_URL } from './constants';
var FILEROBOT_SECOND_LEVEL_DOMAIN = 'filerobot';
var DEFAULT_FILEROBOT_SUBDOMAIN_PROD = 'assets';
var DEFAULT_FILEROBOT_SUBDOMAIN_DEV = 'assets-dev';
var TOP_LEVEL_DOMAIN = 'com';

/**
 * Ge preview url from filerobot url
 *
 * Based on documentation https://scaleflexhq.atlassian.net/wiki/spaces/DEVOPS/pages/166199297/Delivery+Filerobot+Hub+Thumbs+v3
 *
 * There are 2 cases:
 * 1) when there is v7 in the url
 * v2 https://fldytuwm.filerobot.com/v7/120049.jpg into v3 https://assets.filerobot.com/fldytuwm/120049.jpg
 * v2 https://cdn.scaleflex.com/cloudimage.io/checkerboard.svg?vh=938ef5 into v3 https://assets.filerobot.com/scaleflex/cloudimage.io/checkerboard.svg?vh=938ef5
 *
 * 2)when there is no v7 in the url
 * v2 https://fyjnhqim.filerobot.com/ganchev/test_files+doubled/01+-+StyleSense+-+Falsche+Darstellung.png?vh=2b64bd into https://assets.filerobot.com/fyjnhqim/ganchev/test_files+doubled/01+-+StyleSense+-+Falsche+Darstellung.png?vh=2b64bd
 * v2 https://fyjnhqim.filerobot.com/.internal/video_thumbnails/2oaTbKYAtv/20220818_112552.jpg into https://assets.filerobot.com/fyjnhqim/.internal/video_thumbnails/2oaTbKYAtv/20220818_112552.jpg
 *
 * @returns {string} -- New url based on the rules above
 *
 * @param {string} url -- Filerobot file url
 */
export default (function (_ref) {
  var _url$match;
  var _ref$url = _ref.url,
    url = _ref$url === void 0 ? '' : _ref$url,
    isDevEnv = _ref.isDevEnv,
    isHubMode = _ref.isHubMode,
    containerToken = _ref.containerToken;
  var _ref2 = ((_url$match = url.match(FILEROBOT_FILE_URL_REGEX)) === null || _url$match === void 0 ? void 0 : _url$match.groups) || {},
    protocol = _ref2.protocol,
    token = _ref2.token,
    secondLevelDomain = _ref2.secondLevelDomain,
    topLevelDomain = _ref2.topLevelDomain;
  if (url.includes('blob:')) return url;
  if (url.includes(FILEROBOT_V3_URL)) {
    if (isDevEnv) {
      return url.replace(DEFAULT_FILEROBOT_SUBDOMAIN_PROD, DEFAULT_FILEROBOT_SUBDOMAIN_DEV);
    }
    return url;
  }
  var debug = function debug() {
    var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    if (localStorage.getItem('debug_previews') !== '1') {
      return;
    }
    console.trace(_objectSpread(_objectSpread({}, data), {}, {
      url: url,
      isDevEnv: isDevEnv,
      isHubMode: isHubMode,
      containerToken: containerToken,
      protocol: protocol,
      token: token,
      secondLevelDomain: secondLevelDomain,
      topLevelDomain: topLevelDomain
    }));
  };

  // TODO: refactor to more sustainable parameter
  if (isHubMode) {
    var matchFilerobotCdnUrlRegExp = new RegExp("".concat(protocol).concat(token, "\\.").concat(secondLevelDomain, "\\.").concat(topLevelDomain, "\\/(v7\\/)?"));
    var previewToken = isDevEnv ? DEFAULT_FILEROBOT_SUBDOMAIN_DEV : DEFAULT_FILEROBOT_SUBDOMAIN_PROD;
    var previewUrl = "".concat(protocol).concat(previewToken, ".").concat(FILEROBOT_SECOND_LEVEL_DOMAIN, ".").concat(TOP_LEVEL_DOMAIN, "/").concat(containerToken, "/");
    debug({
      previewUrl: previewUrl,
      finalUrl: url.replace(matchFilerobotCdnUrlRegExp, previewUrl)
    });
    return url.replace(matchFilerobotCdnUrlRegExp, previewUrl);
  }
  debug();
  return url;
});