function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Retrieves the value of a nested property from an object using a string key.
 *
 * @param {string} key - The string key representing the nested property.
 * @param {object} item - The object from which to retrieve the nested property.
 * @return {*} - The value of the nested property.
 */
export var getItemKey = function getItemKey(key, item) {
  if (key.includes('.')) {
    var properties = key.split('.');
    return properties.reduce(function (property, prop) {
      return property[prop];
    }, item);
  } else {
    return item[key];
  }
};

/**
 * Generates a normalized version of the given items array.
 *
 * @param {Array} items - The array of items to be normalized.
 * @param {Object} options - options for the function, consists of the following.
    * @param {Object} extraProps - (optional) Additional properties to add to each normalized item.
    * @param {string} key - (optional) The key to use as the unique identifier for each item.
    * @param {string} returnedKey - (optional) the key used in the function's returned's object.
 * @return {Object} An object containing the normalized slices and an array of UUIDs.
 */
var getNormalizedItems = function getNormalizedItems(items, options) {
  var _ref = options || {},
    _ref$extraProps = _ref.extraProps,
    extraProps = _ref$extraProps === void 0 ? {} : _ref$extraProps,
    _ref$key = _ref.key,
    key = _ref$key === void 0 ? 'uuid' : _ref$key,
    _ref$returnedKey = _ref.returnedKey,
    returnedKey = _ref$returnedKey === void 0 ? 'uuids' : _ref$returnedKey;
  var normalizedSlices = {};
  var normalizedItemsUuids = [];
  items.forEach(function (item) {
    var itemKey = getItemKey(key, item);
    var normalizedItem = _objectSpread(_objectSpread({}, item), extraProps);
    normalizedSlices[itemKey] = normalizedItem;
    normalizedItemsUuids.push(itemKey);
  });
  return _defineProperty({
    normalizedSlices: normalizedSlices
  }, returnedKey, normalizedItemsUuids);
};
export default getNormalizedItems;