/**
 * Returns a timestamp in the format of `hours:minutes Am or PM`
 */

export default function getTime() {
  var showAmPm = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var i18n = arguments.length > 1 ? arguments[1] : undefined;
  var date = new Date();
  var hours = date.getHours();
  var minutes = date.getMinutes();
  var ampm = hours >= 12 ? (i18n === null || i18n === void 0 ? void 0 : i18n('mutualizedTimePeriodPm')) || 'PM' : (i18n === null || i18n === void 0 ? void 0 : i18n('mutualizedTimePeriodAm')) || 'AM';
  hours = hours % 12;
  hours = hours || 12; // the hour '0' should be '12'
  hours = hours < 10 ? '0' + hours : hours;
  minutes = minutes < 10 ? '0' + minutes : minutes;
  var strTime = hours + ':' + minutes + (showAmPm ? ' ' + ampm : '');
  return strTime;
}