function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * @param {Date} date
 * @param {object} [translations] - Object with translations. Notice: it's used for Hub.
 * @returns {string} - For example: "18 hours ago"
 */
var humanReadableDate = function humanReadableDate(date, translationsList) {
  var translations = _objectSpread({
    ago: 'ago',
    second: 'second',
    seconds: 'seconds',
    minute: 'minute',
    minutes: 'minutes',
    hour: 'hour',
    hours: 'hours',
    day: 'day',
    days: 'days',
    month: 'month',
    months: 'months',
    year: 'year',
    years: 'years'
  }, translationsList || {});
  var timeAgo = function timeAgo(interval, periodMultiple, periodSingle) {
    return "".concat(Math.floor(interval), " ").concat(Math.floor(interval) > 1 ? periodMultiple : periodSingle, " ").concat(translations.ago);
  };
  var seconds = Math.floor((new Date() - new Date(date)) / 1000);
  var interval = seconds / 31536000;
  if (interval > 1) return timeAgo(interval, translations.years, translations.year);
  interval = seconds / 2592000;
  if (interval > 1) return timeAgo(interval, translations.months, translations.month);
  interval = seconds / 86400;
  if (interval > 1) return timeAgo(interval, translations.days, translations.day);
  interval = seconds / 3600;
  if (interval > 1) return timeAgo(interval, translations.hours, translations.hour);
  interval = seconds / 60;
  if (interval > 1) return timeAgo(interval, translations.minutes, translations.minute);
  interval = seconds;
  return timeAgo(interval, translations.seconds, translations.second);
};
export default humanReadableDate;