import { BYTES_TO_MEGA_BYTES, LARGE_FILE_SIZE_IN_MB } from './constants';
import isAi from './isAi';
import isEps from './isEps';
import isJpg from './isJpg';
import isTiff from './isTiff';
export default function isCloudimageFastPreviewSupported(file) {
  if (!file) return false;
  var _ref = (file === null || file === void 0 ? void 0 : file.size) || {},
    _ref$bytes = _ref.bytes,
    bytes = _ref$bytes === void 0 ? 1 : _ref$bytes;
  var isLargeJpgFile = bytes / BYTES_TO_MEGA_BYTES > LARGE_FILE_SIZE_IN_MB && isJpg(file);
  if (isTiff(file) || isAi(file) || isEps(file) || isLargeJpgFile) {
    return true;
  }
  return false;
}