/**
 * Checks if the browser supports Drag & Drop (not supported on mobile devices, for example).
 * @property {HTMLElement} htmlElement
 * @returns {boolean}
 */
export default function isDragDropSupported(htmlElement) {
  var element = htmlElement || document.createElement('div');
  if (element !== document) {
    if (!('draggable' in element) || !('ondragstart' in element && 'ondrop' in element)) {
      return false;
    }
  }
  if (!('FormData' in window)) {
    return false;
  }
  if (!('FileReader' in window)) {
    return false;
  }
  return true;
}