import isImage from './isImage';
import isPdf from './isPdf';
import isOpenedFromAdobe from './isOpenedFromAdobe';
import isSupportedVideo from './isSupportedVideo';
import isFontFile from './isFontFile';
import isTemplateFile from './isTemplateFile';
export default function isPreviewSupported(file) {
  // Checking if we could show a preview for this item or not
  if (isImage(file) || isPdf(file) && !isOpenedFromAdobe() || isSupportedVideo(file) && !isOpenedFromAdobe() || isFontFile(file) || isTemplateFile(file)) {
    return true;
  }
  return false;
}