var VALID_PROTOCOLS = ['http', 'https', 'ftp'];
var isValidUri = function isValidUri() {
  var uri = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  if (typeof uri !== 'string') {
    return false;
  }

  // to prevent javascript: for some security reasons
  if (uri.trim().toLowerCase().startsWith('javascript:')) {
    return false;
  }
  var isProtocol = VALID_PROTOCOLS.some(function (protocol) {
    return uri === null || uri === void 0 ? void 0 : uri.startsWith(protocol);
  });
  var uriRex = isProtocol ? /^(http|https|ftp):\/\/[^\s.]+\.[^\s]+$/ : /^(www\.[^:/]+\.[^/]+|[^:/]+:[^/]+)$/;
  return uriRex.test(uri);
};
export default isValidUri;