function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import generateMetadataDefaultState from '@filerobot/utils/lib/metadata/generateMetadataDefaultState';

/**
 * @param {object[]} metaDataGroups
 * @param {object} item - File or folder
 * @param {object[]} metaRegionalGroups
 * @returns {object} - Item metadata state
 */
export function generateItemMetadataState(metaDataGroups, item, metaRegionalGroups) {
  var defaultState = generateMetadataDefaultState(metaDataGroups, metaRegionalGroups);
  var itemMetadataState = _objectSpread(_objectSpread({}, defaultState), JSON.parse(JSON.stringify(item.meta || {})));

  /**
   * Sometimes we have cases when field had simple value like string (ex: {title: "My title"}) and then
   * field config was changed and now we have regional_variants. Now {title: {en: "Eng title", fr: "title"}}
   */
  (metaDataGroups || []).forEach(function (group) {
    ((group || {}).fields || []).forEach(function (field) {
      var _metaRegionalGroups$f;
      var fieldRegionalVariants = metaRegionalGroups === null || metaRegionalGroups === void 0 ? void 0 : (_metaRegionalGroups$f = metaRegionalGroups.find(function (group) {
        return group.uuid === (field === null || field === void 0 ? void 0 : field.regional_variants_group_uuid);
      })) === null || _metaRegionalGroups$f === void 0 ? void 0 : _metaRegionalGroups$f.variants;
      var fieldHasRegionalVars = (fieldRegionalVariants || []).length > 0;
      var isStateValueObject = _typeof(itemMetadataState[field.key]) === 'object' && !Array.isArray(itemMetadataState[field.key]) && itemMetadataState[field.key] !== null;
      if (fieldHasRegionalVars && !isStateValueObject || !fieldHasRegionalVars && isStateValueObject) {
        itemMetadataState[field.key] = defaultState[field.key];
      }
      if ((field === null || field === void 0 ? void 0 : field.type) === 'tags' && fieldHasRegionalVars) {
        // Fix bug https://sfx.li/6AGcWPsVyfZakK (also we need 2 fixed: BE and @scaleflex/ui)
        itemMetadataState[field.key] = itemMetadataState[field.key] || {};
        fieldRegionalVariants.forEach(function (regVar) {
          var _itemMetadataState$fi;
          var value = (_itemMetadataState$fi = itemMetadataState[field.key]) === null || _itemMetadataState$fi === void 0 ? void 0 : _itemMetadataState$fi[regVar === null || regVar === void 0 ? void 0 : regVar.api_value];
          itemMetadataState[field.key][regVar === null || regVar === void 0 ? void 0 : regVar.api_value] = adaptStringifiedArray(value);
        });
      }
    });
  });
  return itemMetadataState;
}
function adaptStringifiedArray(value) {
  if (value) {
    if (Array.isArray(value)) {
      return value;
    } else if (typeof value === 'string') {
      try {
        var arrayVal = JSON.parse(value);
        if (arrayVal && Array.isArray(arrayVal)) {
          return arrayVal;
        }
      } catch (error) {
        console.warn("Meta tag field has not valid value, must be an array but we receive \"".concat(value, "\""));
      }
    }
  }
  return [];
}