/**
 * @param {{fields: object}[]} metabaseGroups
 * @param {object[]} metaRegionalGroups
 * @returns {object}
 */
function generateMetadataDefaultState(metabaseGroups, metaRegionalGroups) {
  var defaultMetadata = {};
  (metabaseGroups || []).forEach(function (group) {
    ((group || {}).fields || []).filter(function (field) {
      return field.key;
    }).forEach(function (field) {
      var _metaRegionalGroups$f;
      var value = typeof field.default_value !== 'undefined' ? field.default_value : ['tags', 'multi-select'].indexOf(field.type) > -1 ? [] : null;
      var fieldRegionalVariants = metaRegionalGroups === null || metaRegionalGroups === void 0 ? void 0 : (_metaRegionalGroups$f = metaRegionalGroups.find(function (group) {
        return group.uuid === (field === null || field === void 0 ? void 0 : field.regional_variants_group_uuid);
      })) === null || _metaRegionalGroups$f === void 0 ? void 0 : _metaRegionalGroups$f.variants;
      if (fieldRegionalVariants && Array.isArray(fieldRegionalVariants)) {
        defaultMetadata[field.key] = defaultMetadata[field.key] || {};
        fieldRegionalVariants.forEach(function (_ref) {
          var regionalVariantKey = _ref.api_value;
          defaultMetadata[field.key][regionalVariantKey] = value;
        });
      } else {
        defaultMetadata[field.key] = value;
      }
    });
  });
  return defaultMetadata;
}
export default generateMetadataDefaultState;