import { MAX_LONGITUDE, MIN_LONGITUDE, MAX_LATITUDE, MIN_LATITUDE } from '@filerobot/common/lib/MetaData/MetaDataFieldTypes/MetadataGeoPointField/constants';
import getMetadataFieldGeoPointValue from './getMetadataFieldGeoPointValue';
var getGeoPointValidationErrors = function getGeoPointValidationErrors(_ref) {
  var _ref$geoPoint = _ref.geoPoint,
    geoPoint = _ref$geoPoint === void 0 ? '' : _ref$geoPoint,
    _ref$showDistanceFiel = _ref.showDistanceField,
    showDistanceField = _ref$showDistanceFiel === void 0 ? false : _ref$showDistanceFiel;
  if (!geoPoint || typeof geoPoint !== 'string') return {};
  var baseGeoPoint = geoPoint.replace('~', '');
  var errors = {};
  var _ref2 = getMetadataFieldGeoPointValue(baseGeoPoint, showDistanceField) || {},
    longitude = _ref2.longitude,
    latitude = _ref2.latitude,
    distance = _ref2.distance;
  if (!longitude && !latitude) {
    return errors;
  }
  var longitudeNum = Number(longitude);
  var latitudeNum = Number(latitude);
  var isLongitudeValid = longitudeNum >= MIN_LONGITUDE && longitudeNum <= MAX_LONGITUDE;
  var isLatitudeValid = latitudeNum >= MIN_LATITUDE && latitudeNum <= MAX_LATITUDE;
  if (showDistanceField && !distance) errors.distance = 'metadataDistanceGeoPointFieldError';
  if (!isLongitudeValid) errors.longitude = 'metadataLongitudeGeoPointLimitFieldError';
  if (!isLatitudeValid) errors.latitude = 'metadataLatitudeGeoPointLimitFieldError';
  if (!longitude || !latitude) {
    if (!longitude) errors.longitude = 'metadataLongitudeGeoPointFieldError';
    if (!latitude) errors.latitude = 'metadataLatitudeGeoPointFieldError';
    return errors;
  }
  return errors;
};
export default getGeoPointValidationErrors;