function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import getMetadataGroups from './getMetadataGroups';
import updateValidationErrors from './updateValidationErrors';
import { METADATA_MODEL_TYPE_IDS } from '../constants';
import { checkFileOrFolderNameValidation } from '../checkFileOrFolderNameValidation';
var validateItemMetadata = function validateItemMetadata(_ref) {
  var metadata = _ref.metadata,
    itemMeta = _ref.itemMeta,
    itemMetadataErrors = _ref.itemMetadataErrors,
    i18n = _ref.i18n,
    fileName = _ref.fileName;
  var model = metadata.model,
    regionalGroups = metadata.regionalGroups,
    _metadata$modelType = metadata.modelType,
    modelType = _metadata$modelType === void 0 ? METADATA_MODEL_TYPE_IDS.FILES : _metadata$modelType;
  var metaDataGroups = getMetadataGroups(model, modelType);
  var errors = _objectSpread({}, itemMetadataErrors || {});
  (metaDataGroups || []).forEach(function (group) {
    (group.fields || []).forEach(function (fieldItem) {
      var _regionalGroups$find;
      var fieldRegionalVariants = regionalGroups === null || regionalGroups === void 0 ? void 0 : (_regionalGroups$find = regionalGroups.find(function (group) {
        return group.uuid === (fieldItem === null || fieldItem === void 0 ? void 0 : fieldItem.regional_variants_group_uuid);
      })) === null || _regionalGroups$find === void 0 ? void 0 : _regionalGroups$find.variants;
      var commonProps = {
        errors: errors,
        key: fieldItem.key,
        fieldValidation: fieldItem.validation,
        canEdit: fieldItem.can_edit,
        i18n: i18n
      };
      if (fieldRegionalVariants && Array.isArray(fieldRegionalVariants)) {
        fieldRegionalVariants.forEach(function (_ref2, index) {
          var _itemMeta$fieldItem$k;
          var regionalVariantKey = _ref2.api_value;
          // When field is required and has reg variants, for example ["en", "fr", "de"] we should check only first variant "en" and skip "fr" and "de"
          var shouldCheckIsRequired = index === 0;
          errors = updateValidationErrors(_objectSpread(_objectSpread({}, commonProps), {}, {
            regionalVariantFieldKey: regionalVariantKey,
            fieldValue: itemMeta === null || itemMeta === void 0 ? void 0 : (_itemMeta$fieldItem$k = itemMeta[fieldItem.key]) === null || _itemMeta$fieldItem$k === void 0 ? void 0 : _itemMeta$fieldItem$k[regionalVariantKey],
            isFieldRequired: shouldCheckIsRequired ? fieldItem.required : false
          }));
        });
      } else {
        errors = updateValidationErrors(_objectSpread(_objectSpread({}, commonProps), {}, {
          fieldValue: itemMeta === null || itemMeta === void 0 ? void 0 : itemMeta[fieldItem.key],
          isFieldRequired: fieldItem.required,
          fieldType: fieldItem.type
        }));
      }
    });
  });
  var allErrors = errors;
  if (fileName) {
    if (checkFileOrFolderNameValidation(fileName)) {
      allErrors = _objectSpread({
        name: i18n('explorerFileRenameInvalidNameDesc')
      }, allErrors);
    }
  }
  return {
    isValid: Object.keys(errors).length === 0,
    errors: allErrors
  };
};
export default validateItemMetadata;