var removeUrlParamsWithRegex = function removeUrlParamsWithRegex() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  if (!Array.isArray(params) || params.length === 0) return url;
  var updatedUrl = url;
  params.forEach(function (param) {
    var regex = new RegExp("[?&]".concat(param, "=[^&]*(&|$)"));
    updatedUrl = updatedUrl.replace(regex, function (_, p1) {
      return p1 === '&' ? '?' : '';
    });
  });
  return updatedUrl.replace(/[?&]$/, '');
};
export default removeUrlParamsWithRegex;