var openFullscreen = function openFullscreen(element) {
  if (element.requestFullscreen) {
    element.requestFullscreen();
  } else if (element.webkitRequestFullscreen) {
    element.webkitRequestFullscreen();
  } else if (element.msRequestFullscreen) {
    element.msRequestFullscreen();
  }
};
var closeFullscreen = function closeFullscreen() {
  if (document.exitFullscreen) {
    document.exitFullscreen();
  } else if (document.webkitExitFullscreen) {
    document.webkitExitFullscreen();
  } else if (document.msExitFullscreen) {
    document.msExitFullscreen();
  }
};
var toggleElementFullscreen = function toggleElementFullscreen(element) {
  var isFullscreened = Boolean(document.fullscreenElement);
  if (isFullscreened) {
    closeFullscreen();
    return;
  }
  openFullscreen(element);
};
export default toggleElementFullscreen;